<?php
/*
     999999999          999999999     kkkkkkkk                            
   99:::::::::99      99:::::::::99   k::::::k                            
 99:::::::::::::99  99:::::::::::::99 k::::::k                            
9::::::99999::::::99::::::99999::::::9k::::::k                            
9:::::9     9:::::99:::::9     9:::::9 k:::::k    kkkkkkk   ooooooooooo   
9:::::9     9:::::99:::::9     9:::::9 k:::::k   k:::::k  oo:::::::::::oo 
 9:::::99999::::::9 9:::::99999::::::9 k:::::k  k:::::k  o:::::::::::::::o
  99::::::::::::::9  99::::::::::::::9 k:::::k k:::::k   o:::::ooooo:::::o
    99999::::::::9     99999::::::::9  k::::::k:::::k    o::::o     o::::o
         9::::::9           9::::::9   k:::::::::::k     o::::o     o::::o
        9::::::9           9::::::9    k:::::::::::k     o::::o     o::::o
       9::::::9           9::::::9     k::::::k:::::k    o::::o     o::::o
      9::::::9           9::::::9     k::::::k k:::::k   o:::::ooooo:::::o
     9::::::9           9::::::9      k::::::k  k:::::k  o:::::::::::::::o
    9::::::9           9::::::9       k::::::k   k:::::k  oo:::::::::::oo 
   99999999           99999999        kkkkkkkk    kkkkkkk   ooooooooooo   

Just using 99ko
2009 - 2014
99ko http://99ko.hellojo.fr

Author :
jonathan Coulet (j.coulet@gmail.com)

Contributors :
Florent Fortat (florent.fortat@maxgun.fr)
Frédéric Kaplon (frederic.kaplon@me.com)
*/

session_start();
define('ROOT', './');
include_once(ROOT.'common/core.lib.php');
if (utilPhpVersion() < '5.1.2') {
	die("Vous devez disposer d'un serveur équipé de PHP 5.1.2 ou plus !");
}
utilSetMagicQuotesOff();
$error = false;
$resetPassword = false;
define('DEFAULT_PLUGIN', 'page');
$pluginsManager = new pluginsManager();
$hooks = array();
if (isset($_GET['updateto'])) {
	$coreConf = getCoreConf();
	if ($error) {
		$data['msg'] = "Problème lors de la mise à jour";
		$data['msgType'] = "error";
	} else {
		$data['msg'] = "Mise à jour effectuée";
		$data['msgType'] = "success";
	}
	if ($resetPassword) {
		$data['msg'] .= "\nLe mot de passe admin a été réinitialisé : " . $mdp;
	}
} else {
	if (file_exists(ROOT.'data/config.txt')) {
		die();
	}
	@chmod(ROOT.'.htaccess', 0666);
	$mdp = rand(1000, 9999); //Mot de Passe aléatoire
	if(!file_exists(ROOT.'.htaccess')){
		if (!@file_put_contents(ROOT.'.htaccess', "Options -Indexes", 0666)) {
			$error = true;
		}
	}
	if (!is_dir(ROOT.'data/') && (!@mkdir(ROOT.'data/') || !@chmod(ROOT.'data/', 0777))) {
		$error = true;
	}
	if(!file_exists(ROOT.'data/.htaccess')){
		if (!@file_put_contents(ROOT.'data/.htaccess', "deny from all", 0666)) {
			$error = true;
		}
	}
	if (!is_dir(ROOT.'data/plugin/') && (!@mkdir(ROOT.'data/plugin/') || !@chmod(ROOT.'data/plugin/', 0777))) {
		$error = true;
	}
	if (!is_dir(ROOT.'data/upload/') && (!@mkdir(ROOT.'data/upload/') || !@chmod(ROOT.'data/upload/', 0777))) {
		$error = true;
	}
	if(!file_exists(ROOT.'data/upload/.htaccess')){
		if (!@file_put_contents(ROOT.'data/upload/.htaccess', "allow from all", 0666)) {
			$error = true;
		}
	}
	$key = uniqid(true);
	if(!file_exists(ROOT.'data/key.php') && !@file_put_contents(ROOT.'data/key.php', "<?php define('KEY', '$key'); ?>", 0666)){
		$error = true;
	}
	include(ROOT.'data/key.php');
	$config = array(
		'siteName' => "Démo",
		'siteDescription' => "Un site propulsé par 99Ko",
		'adminPwd' => encrypt($mdp), 
		'theme' => 'default',
		'adminEmail'=> 'you@domain.com',
		'siteUrl' => getSiteUrl(),
		'defaultPlugin' => 'page',
		'urlRewriting' => '0',
		'siteLang' => 'fr',
	);
	if(!@file_put_contents(ROOT.'data/config.txt', json_encode($config))
		||	!@chmod('data/config.txt', 0666)) {
		$error = true;
	}
	foreach ($pluginsManager->getPlugins() as $plugin) {
		if ($plugin->getLibFile()) {
			include_once($plugin->getLibFile());
			if (!$plugin->isInstalled()) {
				$pluginsManager->installPlugin($plugin->getName());
			}
		}
	}
	foreach ($pluginsManager->getPlugins() as $plugin) {
		foreach ($plugin->getHooks() as $hookName=>$function) {
			$hooks[$hookName][] = $function;
		}
	}
	if ($error) {
		$data['msg'] = "Problème lors de l'installation";
		$data['msgType'] = "error";
	} else {
		$data['msg'] = "99ko est installé\nLe mot de passe admin par défaut est : $mdp\nModifiez-le dès votre première connexion\nSupprimez également le fichier install.php";
		$data['msgType'] = "success";
		eval(callHook('installSuccess'));

		$_SESSION['msg_install'] = $data['msg'];
		header('location:admin/index.php');
	}
}
?>
<!doctype html>  
<!--[if IE 6 ]><html lang="fr" class="ie6"> <![endif]-->
<!--[if IE 7 ]><html lang="fr" class="ie7"> <![endif]-->
<!--[if IE 8 ]><html lang="fr" class="ie8"> <![endif]-->
<!--[if (gt IE 7)|!(IE)]><!-->
<html lang="fr"><!--<![endif]-->
<head>
       <meta charset="utf-8">  
       <title>99ko - Installation</title>
	<!-- css -->
	<link rel="stylesheet" href="admin/css/style.css" media="all">
	<link rel="stylesheet" href="admin/css/common.css" media="all">
	<!-- Personnalisation des liens, sidebar, contenu -->	
	<link rel="stylesheet" href="admin/css/color_defaut.css" />
</head>
<body>
       <div id="content">      
<section id="home">
       <?php showMsg($data['msg'], $data['msgType']); ?>
</section>
    </div>
</body>
</html>