<?php
#### NE PAS SUPPRIMER

if(!defined('ROOT')) die();

#### INSTALLATION DU PLUGIN

function pageInstall(){
	$pageManager = new pageManager();
	if(count($pageManager->getItems()) < 1){
		$page = new page();
		$page->setName('Accueil');
		$page->setPosition(1);
		$page->setIsHomepage(1);
		$page->setContent('<img class="logo" alt="99ko" src="admin/images/logo.png"/>
<p>L\'installation s\'est déroulée avec succès.<br />Vous pouvez maintenant vous connecter à l\'administration en utilisant le lien en bas de page et les informations de connexion qui vous ont été communiqués lors de l\'installation.</p>
<p>N\'oubliez pas de modifier vos informations de connexion et de supprimer le fichier install de votre FTP.</p>');
		$page->setIsHidden(0);
		$page->setFile('home.php');
		$pageManager->save($page);
		$page = new page();
		$page = new page();
		$page->setName('Page 2');
		$page->setPosition(2);
		$page->setIsHomepage(0);
		$page->setContent("<p>Iamque lituis cladium concrepantibus internarum non celate ut antea turbidum saeviebat ingenium a veri consideratione detortum et nullo inpositorum vel conpositorum fidem sollemniter inquirente nec discernente a societate noxiorum insontes velut exturbatum e iudiciis fas omne discessit, et causarum legitima silente defensione carnifex rapinarum sequester et obductio capitum et bonorum ubique multatio versabatur per orientales provincias, quas recensere puto nunc oportunum absque Mesopotamia digesta, cum bella Parthica dicerentur, et Aegypto, quam necessario aliud reieci ad tempus.</p><p>Haec igitur lex in amicitia sanciatur, ut neque rogemus res turpes nec faciamus rogati. Turpis enim excusatio est et minime accipienda cum in ceteris peccatis, tum si quis contra rem publicam se amici causa fecisse fateatur. Etenim eo loco, Fanni et Scaevola, locati sumus ut nos longe prospicere oporteat futuros casus rei publicae. Deflexit iam aliquantum de spatio curriculoque consuetudo maiorum.</p>");
		$page->setIsHidden(0);
		$page->setFile('');
		$pageManager->save($page);
		$page = new page();
		$page = new page();
		$page->setName('Texte support');
		$page->setPosition(3);
		$page->setIsHomepage(0);
		$page->setContent("<p class=\"links\">Téléchargez une version plus récente, des plugins et des thèmes sur <a href=\"http://99ko.hellojo.fr\">le site officiel</a>. En cas de problème avec 99ko, rendez-vous sur le <a href=\"http://99ko.hellojo.fr\">forum d'entraide</a>.</p>");
		$page->setIsHidden(1);
		$page->setFile('');
		$pageManager->save($page);
	}
}

#### CODE DU PLUGIN

define('PAGE_DATA', ROOT.'data/plugin/page/');
$pageManager = new pageManager();

foreach($pageManager->getItems() as $k=>$page) if(!$page->getIsHidden()){
	$temp = ($coreConf['defaultPlugin'] == 'page' && $page->getIsHomepage()) ? $coreConf['siteUrl'] : rewriteUrl('page', array('name' => $page->getName(), 'id' => $page->getId()));
	$pluginsManager->getPlugin('page')->addToNavigation($page->getName(), $temp);
}

class pageManager{
	private $items;
	
	public function __construct(){
		$data = array();
		if(is_dir(PAGE_DATA)){
			$dataNotSorted = array();
			$items = utilScanDir(PAGE_DATA, array('config.txt'));
			foreach($items['file'] as $k=>$file){
				$temp = json_decode(@file_get_contents(ROOT.'data/plugin/page/'.$file), true);
				$dataNotSorted[] = $temp;
			}
			$dataSorted = utilSort2DimArray($dataNotSorted, 'position', 'num');
			foreach($dataSorted as $page){
				$data[] = new page($page);
			}
		}
		$this->items = $data;
	}
	
	public function getItems(){
		return $this->items;
	}
	
	public function create($id){
		foreach($this->items as $page){
			if($page->getId() == $id) return $page;
		}
		return false;
	}
	
	public function createHomepage(){
		foreach($this->items as $page){
			if($page->getIshomepage()) return $page;
		}
		return false;
	}
	
	public function save($obj){
		$id = $obj->getId();
		if($id == '') $id = uniqid();
		$data = array(
			'id' => $id,
			'name' => $obj->getName(),
			'position' => $obj->getPosition(),
			'isHomepage' => $obj->getIsHomepage(),
			'content' => $obj->getContent(),
			'isHidden' => $obj->getIsHidden(),
			'file' => $obj->getFile(),
			'mainTitle' => $obj->getMainTitle(),
			'metaDescriptionTag' => $obj->getMetaDescriptionTag(),
		);
		if($obj->getIsHomepage() > 0) $this->initIshomepageVal();
		if(@file_put_contents(PAGE_DATA.$id.'.txt', json_encode($data), 0666)){
			$this->repairPositions($obj);
			return true;
		}
		return false;
	}
	
	public function del($obj){
		if($obj->getIsHomepage() < 1 && $this->count() > 1){
			if(@unlink(PAGE_DATA.$obj->getId().'.txt')) return true;
		}
		return false;
	}
	
	public function count(){
		return count($this->items);
	}
	
	public function listFiles(){
		$data = array();
		$items = utilScanDir(ROOT.'theme/'.getCoreConf('theme').'/', array('header.php', 'footer.php', 'style.css'));
		foreach($items['file'] as $file){
			if(in_array(utilGetFileExtension($file), array('htm', 'html', 'txt', 'php'))) $data[] = $file;
		}
		return $data;
	}

	private function initIshomepageVal(){
		foreach($this->items as $obj){
			$obj->setIsHomepage(0);
			$this->save($obj);
		}
	}
	
	private function repairPositions($currentObj){
		foreach($this->items as $obj) if($obj->getId() != $currentObj->getId()){
			$pos = $obj->getPosition();
			if($pos == $currentObj->getPosition()){
				$obj->setPosition($pos+1);
				$this->save($obj);
			}
		}
	}
}

class page{
	private $id;
	private $name;
	private $position;
	private $isHomepage;
	private $content;
	private $isHidden;
	private $file;
	private $mainTitle;
	private $metaDescriptionTag;
	
	public function __construct($val = array()){
		if(count($val) > 0){
			$this->id = $val['id'];
			$this->name = $val['name'];
			$this->position = $val['position'];
			$this->isHomepage = $val['isHomepage'];
			$this->content = $val['content'];
			$this->isHidden = $val['isHidden'];
			$this->file = $val['file'];
			$this->mainTitle = $val['mainTitle'];
			$this->metaDescriptionTag = $val['metaDescriptionTag'];
		}
	}

	public function setName($val){
		$val = trim($val);
		if($val == '') $val = "Page sans nom";
		$this->name = $val;
	}
	
	public function setPosition($val){
		$this->position = intval($val);
	}
	
	public function setIsHomepage($val){
		$this->isHomepage = trim($val);
	}
	
	public function setContent($val){
		$this->content = trim($val);
	}
	
	public function setIsHidden($val){
		$this->isHidden = intval($val);
	}
	
	public function setFile($val){
		$this->file = trim($val);
	}
	
	public function setMainTitle($val){
		$this->mainTitle = trim($val);
	}
	
	public function setMetaDescriptionTag($val){
		$val = trim($val);
		if(mb_strlen($val) > 150) $val = mb_strcut($val, 0, 150).'...';
		$this->metaDescriptionTag = $val;
	}

	public function getId(){
		return $this->id;
	}
	
	public function getName(){
		return $this->name;
	}
	
	public function getPosition(){
		return $this->position;
	}
	
	public function getIsHomepage(){
		return $this->isHomepage;
	}
	
	public function getContent(){
		return $this->content;
	}
	
	public function getIsHidden(){
		return $this->isHidden;
	}
	
	public function getFile(){
		return $this->file;
	}
	
	public function getMainTitle(){
		return $this->mainTitle;
	}
	
	public function getMetaDescriptionTag(){
		return $this->metaDescriptionTag;
	}
}

function pageContent($idOrName){
	global $pageManager;
	foreach($pageManager->getItems() as $page){
		if($page->getId() == $idOrName || $page->getName() == $idOrName){
			return $pageManager->create($page->getId())->getContent();
		}
	}
}
?>